# The LearningOnline Network with CAPA
#
# Construction Space Page Wrapper for Construction
#
# (Page Handler
#
# (TeX Content Handler
#
# 05/29/00,05/30 Gerd Kortemeyer)
# 08/30,08/31,09/06,09/14,09/15,09/16,09/19,09/20,09/21,09/23,
# 10/02,10/10,10/14,10/16,10/18,10/19,10/31,11/6,11/14,11/16 Gerd Kortemeyer)
#
# 11/22,11/23,11/28 Gerd Kortemeyer

package Apache::lonconstruct;

use strict;
use Apache::Constants qw(:common :http);

# ================================================================ Main Handler

sub handler {
   my $r=shift;

# -------------------------------------------------------------- Build frameset

   $r->content_type('text/html');
   $r->send_http_header;
   return OK if $r->header_only;

   my $lowerframe=$r->path_info;
   $lowerframe=~s/^\//\/\~/;

   $r->print(<<ENDPAGE);
<html>
<head><title>LON-CAPA Construction Space</title></head>
<frameset rows="50,*">
<frame src='/adm/publisher.html'>
<frame src='$lowerframe' name="LONCAPAToBePublished">
</frameset>
</html>
ENDPAGE
   return OK;
}
1;
__END__







