# The LearningOnline Network with CAPA
# caparesponse definition

package Apache::caparesponse;
use strict;
use capa;

sub BEGIN {
  &Apache::lonxml::register('Apache::caparesponse',('caparesponse'));
}

$Apache::caparesponse::result='';
sub start_caparesponse {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $args ='';
  if ( $#$parstack > -1 ) { $args=$$parstack[$#$parstack]; }
  my $id = &Apache::run::run("{$args;".'return $id}',$safeeval);
  if ($id eq '') { $id = $Apache::lonxml::curdepth; }
  push (@Apache::inputtags::response,$id);
  push (@Apache::inputtags::responselist,$id);
  return '';
  #my $envkey;
  #foreach $envkey (sort keys %ENV) {
  #  Apache::lonxml::debug("$envkey ---- $ENV{$envkey}<br>");
  #}
  #Apache::lonxml::debug("\n<br>\nreal caparesponse<br>\n");
}

sub end_caparesponse {
  my ($target,$token,$parstack,$parser,$safeeval,$style)=@_;
  my $result = '';
  if ( $target eq 'grade' ) {
    if ( defined $ENV{'form.submit'}) {
      $Apache::caparesponse::result='';
      $safeeval->share_from('capa',['&caparesponse_capa_check_answer']);
      my $response = $ENV{'form.HWVAL'.$Apache::inputtags::curvalue};
      if ( $response =~ /[^\s]/) {
	$Apache::lonhomework::results{"resource.submission.$Apache::inputtags::part.$Apache::inputtags::response['-1']"}=$response;
	&Apache::lonxml::debug("submitted a $response<br>\n");
	&Apache::lonxml::debug($$parstack[$#$parstack] . "\n<br>");
	my $expression="&caparesponse_check('".$response."','".
	  $$parstack[$#$parstack].
	    ';my $tol="'.$Apache::inputtags::params{'tol'}.'"'.
	      ';my $sig="'.$Apache::inputtags::params{'sig'}.'"'.
		"');";
	$result = &Apache::run::run($expression,$safeeval);
	my ($ad) = split /:/ , $result;
	$Apache::lonhomework::results{"resource.awarddetail.$Apache::inputtags::part.$Apache::inputtags::response['-1']"}=$ad;
	&Apache::lonxml::debug("$expression");
	&Apache::lonxml::debug("\n<br>result:$Apache::caparesponse::result:$result:$Apache::lonxml::curdepth<br>\n");
      }
    }
  } else {
    #$result .= "The correct answer is ".&Apache::run::run("{$$parstack['-1'];".'return $answer}',$safeeval)."\n";
  }
  #Apache::lonxml::debug("\n<br>\nreal end caparesponse<br>\n");
  pop @Apache::inputtags::response;
  return $result;
}

1;
__END__
 
